/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo,uid, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.userId = uid;
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if(loginInfo.account.length < 4) {
			return callback('账号最短为 4 个字符');
		}
		if(loginInfo.password.length < 4) {
			return callback('密码最短为 4 个字符');
		}
		//alert("login2:"+JSON.stringify(loginInfo));

		localStorage.setItem('users', JSON.stringify(loginInfo));

		var user = JSON.parse(localStorage.getItem("users")); 
		//alert("login3:"+JSON.stringify(user));
		//return callback();
		// return owner.createState(loginInfo.account, callback);
			//return callback('用户名或密码错误');
	};
	//token 是一个令牌
	owner.createState = function(name, callback) {
		var state = owner.getState();
		state.account = name;
		state.token = "1234567";
		owner.setState(state);
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		if(regInfo.account.length < 4) {
			return callback('用户名最短需要 4 个字符');
		}
		if(regInfo.password.length < 4) {
			return callback('密码最短需要 4 个字符');
		}

		//ajax 注册成功后，把用户的账户密码存放本地
		var users = JSON.parse(localStorage.getItem('users') || '[]');
		users.push(regInfo);
		localStorage.setItem('users', JSON.stringify(users));

		
		return callback();
	};
	/**
	 * 获取当前的用户名和密码
	 */
	owner.getUser = function() {
			var userText = localStorage.getItem('users') || "{}";
			if(userText == "{}") {
				return;
			}
			return JSON.parse(userText);
		}

	owner.getUserId = function()  {
		var userText = localStorage.getItem("users") || "{}";
		//alert("本地存储："+userText);
		if(userText == "{}") {
			return;
		}
		return (JSON.parse(userText)).userId;
		//return "1";
		//return false;
	}
		/**
		 * 获取当前状态
		 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		//alert(stateText);
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return(email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 *
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if(!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};
*/
	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
			return JSON.parse(settingsText);
		}
		/**
		 * 获取本地是否安装客户端
		 **/

}(mui, window.app = {}));

function clearUser() {
	//alert("clearUser");
	localStorage.setItem('users', "{}");
	localStorage.clear();
};

function setCustomer(id) {
	if(typeof(id) == 'undefined' || id == '' || id == 'undefined' || id == null){
	  localStorage.setItem("customerId", "");
	}else{
	  localStorage.setItem("customerId", id);
	}
};

function getCustomer() {
	var cid = localStorage.getItem("customerId");
	if(typeof(cid) == 'undefined' || cid == '' || cid == 'undefined' || cid == null){
		return '';
	}else{
		return cid;
	}
};

function setKey(key,value) {
	if(typeof(value) == 'undefined' || value == '' || value == 'undefined' || value == null){
	  localStorage.setItem(key, "");
	}else{
	  localStorage.setItem(key,value);
	}
};

function getKey(id) {
	var val = localStorage.getItem(id);
	if(typeof(val) == 'undefined' || val == '' || val == 'undefined' || val == null){
		return '';
	}else{
		return val;
	}
};